from hashlib import sha256

from checksome.algorithms.algorithm import Algorithm


class SHA256(Algorithm):
    """
    A hash generated by the SHA256 algorithm.
    """

    def __init__(self) -> None:
        self.sha256 = sha256(usedforsecurity=False)

    def digest(self) -> bytes:
        """
        Gets the hash digest.
        """

        return self.sha256.digest()

    def update(self, data: bytes) -> None:
        """
        Adds bytes to the hash.
        """

        self.sha256.update(data)
